<?php
if ( ! class_exists( 'Auto_Car_Repair_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Auto_Car_Repair_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Auto_Car_Repair_Plugin_Activation_WPElemento_Importer {

        private static $auto_car_repair_instance;
        public $auto_car_repair_action_count;
        public $auto_car_repair_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$auto_car_repair_instance) ) {
            self::$auto_car_repair_instance = new self();
          }
          return self::$auto_car_repair_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'auto_car_repair_recommended_plugins', array($this, 'auto_car_repair_recommended_elemento_importer_plugins_array') );

            $auto_car_repair_actions                   = $this->auto_car_repair_get_recommended_actions();
            $this->auto_car_repair_action_count        = $auto_car_repair_actions['count'];
            $this->auto_car_repair_recommended_actions = $auto_car_repair_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function auto_car_repair_recommended_elemento_importer_plugins_array($auto_car_repair_plugins){
            $auto_car_repair_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'auto-car-repair'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'auto-car-repair'),               
            );
            return $auto_car_repair_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'auto-car-repair-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('auto-car-repair-plugin-activation-script', 'auto_car_repair_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'auto-car-repair'),
                    'activating' => esc_html__('Activating', 'auto-car-repair'),
                    'error' => esc_html__('Error', 'auto-car-repair'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'auto-car-repair-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function auto_car_repair_get_recommended_actions() {

            $auto_car_repair_act_count  = 0;
            $auto_car_repair_actions_todo = get_option( 'recommending_actions', array());

            $auto_car_repair_plugins = $this->auto_car_repair_get_recommended_plugins();

            if ($auto_car_repair_plugins) {
                foreach ($auto_car_repair_plugins as $auto_car_repair_key => $auto_car_repair_plugin) {
                    $auto_car_repair_action = array();
                    if (!isset($auto_car_repair_plugin['slug'])) {
                        continue;
                    }

                    $auto_car_repair_action['id']   = 'install_' . $auto_car_repair_plugin['slug'];
                    $auto_car_repair_action['desc'] = '';
                    if (isset($auto_car_repair_plugin['desc'])) {
                        $auto_car_repair_action['desc'] = $auto_car_repair_plugin['desc'];
                    }

                    $auto_car_repair_action['name'] = '';
                    if (isset($auto_car_repair_plugin['name'])) {
                        $auto_car_repair_action['title'] = $auto_car_repair_plugin['name'];
                    }

                    $auto_car_repair_link_and_is_done  = $this->auto_car_repair_get_plugin_buttion($auto_car_repair_plugin['slug'], $auto_car_repair_plugin['name'], $auto_car_repair_plugin['function']);
                    $auto_car_repair_action['link']    = $auto_car_repair_link_and_is_done['button'];
                    $auto_car_repair_action['is_done'] = $auto_car_repair_link_and_is_done['done'];
                    if (!$auto_car_repair_action['is_done'] && (!isset($auto_car_repair_actions_todo[$auto_car_repair_action['id']]) || !$auto_car_repair_actions_todo[$auto_car_repair_action['id']])) {
                        $auto_car_repair_act_count++;
                    }
                    $auto_car_repair_recommended_actions[] = $auto_car_repair_action;
                    $auto_car_repair_actions_todo[]        = array('id' => $auto_car_repair_action['id'], 'watch' => true);
                }
                return array('count' => $auto_car_repair_act_count, 'actions' => $auto_car_repair_recommended_actions);
            }

        }

        public function auto_car_repair_get_recommended_plugins() {

            $auto_car_repair_plugins = apply_filters('auto_car_repair_recommended_plugins', array());
            return $auto_car_repair_plugins;
        }

        public function auto_car_repair_get_plugin_buttion($slug, $name, $function) {
                $auto_car_repair_is_done      = false;
                $auto_car_repair_button_html  = '';
                $auto_car_repair_is_installed = $this->is_plugin_installed($slug);
                $auto_car_repair_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $auto_car_repair_is_activeted = (class_exists($function)) ? true : false;
                if (!$auto_car_repair_is_installed) {
                    $auto_car_repair_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $auto_car_repair_plugin_install_url = wp_nonce_url($auto_car_repair_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $auto_car_repair_button_html        = sprintf('<a class="auto-car-repair-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($auto_car_repair_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'auto-car-repair'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'auto-car-repair')
                    );
                } elseif ($auto_car_repair_is_installed && !$auto_car_repair_is_activeted) {

                    $auto_car_repair_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($auto_car_repair_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $auto_car_repair_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $auto_car_repair_button_html = sprintf('<a class="auto-car-repair-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($auto_car_repair_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'auto-car-repair'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'auto-car-repair')
                    );
                } elseif ($auto_car_repair_is_activeted) {
                    $auto_car_repair_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'auto-car-repair'));
                    $auto_car_repair_is_done     = true;
                }

                return array('done' => $auto_car_repair_is_done, 'button' => $auto_car_repair_button_html);
            }
        public function is_plugin_installed($slug) {
            $auto_car_repair_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $auto_car_repair_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($auto_car_repair_installed_plugins[$auto_car_repair_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $auto_car_repair_keys = array_keys($this->get_installed_plugins());
            foreach ($auto_car_repair_keys as $auto_car_repair_key) {
                if (preg_match('|^' . $slug . '/|', $auto_car_repair_key)) {
                    return $auto_car_repair_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Auto_Car_Repair_Plugin_Activation_WPElemento_Importer::get_instance();